Arch Space/uk: Difference between revisions

From FreeCAD Documentation
(Updating to match new version of source page)
(Updating to match new version of source page)
 
(11 intermediate revisions by 3 users not shown)
Line 1: Line 1:
<languages/>
<languages/>
{{docnav|[[Arch_Roof|Roof]]|[[Arch_Stairs|Stairs]]|[[Arch_Module|Arch]]|IconL=Arch_Roof.svg |IconC=Workbench_Arch.svg |IconR=Arch_Stairs.svg}}


<div class="mw-translate-fuzzy">
<div class="mw-translate-fuzzy">
{{docnav/uk|[[Arch_Roof/uk|Roof/uk]]|[[Arch_Stairs/uk|Stairs/uk]]|[[Arch_Module/uk|Arch]uk]|IconL=Arch_Roof.svg |IconC=Workbench_Arch.svg |IconR=Arch_Stairs.svg}}
{{GuiCommand/uk|Name=Arch Space|Name/uk=Arch Space|Workbenches=[[Arch Module/uk|Arch]]|MenuLocation=Arch → Space|Shortcut=S P}}
</div>

<div class="mw-translate-fuzzy">
{{GuiCommand/uk
|Name=Arch Space|Name/uk=Arch Space
|MenuLocation=Arch → Space
|Workbenches=[[Arch_Workbench/uk|Arch]]
|Shortcut={{KEY|S}} {{KEY|P}}
|SeeAlso=[[Arch Wall/uk]], [[Arch Structure/uk]]
|Version=0.14
}}
</div>
</div>


==Description==
==Description==

The Space tool allows you to define an empty volume, either by basing it on a solid shape, or by defining its boundaries, or a mix of both. If it is based solely on boundaries, the volume is calculated by starting from the bounding box of all the given boundaries, and subtracting the spaces behind each boundary. The space object always defines a solid volume. The floor area of a space object, calculated by intersecting a horizontal plane at the center of mass of the space volume, can also be displayed.
The Space tool allows you to define an empty volume, either by basing it on a solid shape, or by defining its boundaries, or a mix of both. If it is based solely on boundaries, the volume is calculated by starting from the bounding box of all the given boundaries, and subtracting the spaces behind each boundary. The Space object always defines a solid volume. The floor area of a space object, calculated by intersecting a horizontal plane at the center of mass of the space volume, can also be displayed.


[[Image:Arch Space example.jpg|640px]]
[[Image:Arch Space example.jpg|640px]]

{{Caption|Space object created from an existing solid object, then two wall faces are added as boundaries.}}
{{Caption|Space object created from an existing solid object, then two wall faces are added as boundaries.}}


==How to use==
==Usage==


# Select an existing solid object, or faces on boundary objects.
# Select an existing solid object, or faces on boundary objects.
# Invoke the Arch Space command using several methods:
# Press the {{Button|[[Image:Arch_Space.svg|16px]] [[Arch Space]]}} button, or press {{KEY|S}}, {{KEY|P}} keys.
#* Pressing the {{Button|[[Image:Arch_Space.svg|16px]] [[Arch_Space|Arch Space]]}} button in the toolbar.
#* Using the {{KEY|S}} then {{KEY|P}} keyboard keys
#* Using the {{MenuCommand|Arch → Space}} entry from the top menu


=== Limitations ===
=== Limitations ===
Line 53: Line 68:
==Options==
==Options==


* To create zones that group several spaces, use a [[Arch BuildingPart]] and set its IFC type to "Spatial Zone"
* To create zones that group several spaces, use an [[Arch_BuildingPart|Arch BuildingPart]] and set its IFC type to "Spatial Zone".
* The space object has the same display modes as other Arch and Part objects, with one more, called '''Footprint''', that displays only the bottom face of the space. {{Version|0.19}}
* The Space object has the same display modes as other Arch and Part objects, with one more, called '''Footprint''', that displays only the bottom face of the space.


==Scripting==
==Scripting==
{{Emphasis|See also:}} [[Arch API]] and [[FreeCAD Scripting Basics]].


{{Emphasis|See also:}} [[Arch_API|Arch API]] and [[FreeCAD_Scripting_Basics|FreeCAD Scripting Basics]].
The Space tool can be used in [[macros]] and from the [[Python]] console by using the following function:

The Space tool can be used in [[Macros|macros]] and from the [[Python|Python]] console by using the following function:

{{Code|code=
{{Code|code=
Space = makeSpace(objects=None, baseobj=None, name="Space")
Space = makeSpace(objects=None, baseobj=None, name="Space")
Line 65: Line 82:


* Creates a {{incode|Space}} object from the given {{incode|objects}} or {{incode|baseobj}}, which can be
* Creates a {{incode|Space}} object from the given {{incode|objects}} or {{incode|baseobj}}, which can be
** one document object, in which case it becomes the base shape of the space object, or
** one document object, in which case it becomes the base shape of the Space object, or
** a list of selection objects as returned by {{incode|FreeCADGui.Selection.getSelectionEx()}}, or
** a list of selection objects as returned by {{incode|FreeCADGui.Selection.getSelectionEx()}}, or
** a list of tuples {{incode|(object, subobjectname)}}
** a list of tuples {{incode|(object, subobjectname)}}


Example:
Example:

{{Code|code=
{{Code|code=
import FreeCAD, Arch
import FreeCAD, Arch
Line 84: Line 102:


After a space object is created, selected faces can be added to it with the following code:
After a space object is created, selected faces can be added to it with the following code:

{{Code|code=
{{Code|code=
import FreeCAD, FreeCADGui, Draft, Arch
import FreeCAD, FreeCADGui, Draft, Arch
Line 98: Line 117:


Boundaries can also be removed, again by selecting the indicated faces:
Boundaries can also be removed, again by selecting the indicated faces:

{{Code|code=
{{Code|code=
selection = FreeCADGui.Selection.getSelectionEx()
selection = FreeCADGui.Selection.getSelectionEx()
Arch.removeSpaceBoundaries(Space, selection)
Arch.removeSpaceBoundaries(Space, selection)
}}
}}



<div class="mw-translate-fuzzy">
<div class="mw-translate-fuzzy">
{{docnav/uk|[[Arch_Roof/uk|Roof/uk]]|[[Arch_Stairs/uk|Stairs/uk]]|[[Arch_Module/uk|Arch]uk]|IconL=Arch_Roof.svg |IconC=Workbench_Arch.svg |IconR=Arch_Stairs.svg}}
[[Category:Arch/uk]]
</div>
</div>


{{Arch Tools navi}}
{{Arch Tools navi{{#translation:}}}}
{{Userdocnavi{{#translation:}}}}

{{Userdocnavi}}

Latest revision as of 21:34, 6 November 2023

{{docnav/uk|Roof/uk|Stairs/uk|[[Arch_Module/uk|Arch]uk]|IconL=Arch_Roof.svg |IconC=Workbench_Arch.svg |IconR=Arch_Stairs.svg}}

Arch Space

Меню прокату
Arch → Space
Верстаки
Arch
Ярлик за умовчанням
S P
Введено у версії
0.14
Дивись також
Arch Wall/uk, Arch Structure/uk

Description

The Space tool allows you to define an empty volume, either by basing it on a solid shape, or by defining its boundaries, or a mix of both. If it is based solely on boundaries, the volume is calculated by starting from the bounding box of all the given boundaries, and subtracting the spaces behind each boundary. The Space object always defines a solid volume. The floor area of a space object, calculated by intersecting a horizontal plane at the center of mass of the space volume, can also be displayed.

Space object created from an existing solid object, then two wall faces are added as boundaries.

Usage

  1. Select an existing solid object, or faces on boundary objects.
  2. Invoke the Arch Space command using several methods:
    • Pressing the Arch Space button in the toolbar.
    • Using the S then P keyboard keys
    • Using the Arch → Space entry from the top menu

Limitations

Properties

  • ДаніBase: The base object, if any (must be a solid)
  • ДаніBoundaries: A list of optional boundary elements
  • ДаніArea: The computed floor area of this space
  • ДаніFinishFloor: The finishing of the floor of this space
  • ДаніFinishWalls: The finishing of the walls of this space
  • ДаніFinishCeiling: The finishing of the ceiling of this space
  • ДаніGroup: Objects that are included inside this space, such as furniture
  • ДаніSpaceType: The type of this space
  • ДаніFloorThickness: The thickness of the floor finish
  • ДаніNumberOfPeople: The number of people who typically occupy this space
  • ДаніLightingPower: The electric power needed to light this space in Watts
  • ДаніEquipmentPower: The electric power needed by the equipment of this space in Watts
  • ДаніAutoPower: If True, Equipment Power will be automatically filled by the equipment included in this space
  • ДаніConditioning: The type of air conditioning of this space
  • ДаніInternal: Specifies if this space is internal or external
  • ВиглядText: The text to show. Use $area, $label, $tag, $floor, $walls, $ceiling to insert the respective data
  • ВиглядFontName: The name of the font
  • ВиглядTextColor: The color of the text
  • ВиглядFontSize: The size of the text
  • ВиглядFirstLine: The size of the first line of text (multiplies the font size. 1 = same size, 2 = double size, etc..)
  • ВиглядLineSpacing: The space between the lines of text
  • ВиглядTextPosition: The position of the text. Leave (0,0,0) for automatic position
  • ВиглядTextAlign: The justification of the text
  • ВиглядDecimals: The number of decimals to use for calculated texts
  • ВиглядShowUnit: Show the unit suffix or not

Options

  • To create zones that group several spaces, use an Arch BuildingPart and set its IFC type to "Spatial Zone".
  • The Space object has the same display modes as other Arch and Part objects, with one more, called Footprint, that displays only the bottom face of the space.

Scripting

See also: Arch API and FreeCAD Scripting Basics.

The Space tool can be used in macros and from the Python console by using the following function:

Space = makeSpace(objects=None, baseobj=None, name="Space")
  • Creates a Space object from the given objects or baseobj, which can be
    • one document object, in which case it becomes the base shape of the Space object, or
    • a list of selection objects as returned by FreeCADGui.Selection.getSelectionEx(), or
    • a list of tuples (object, subobjectname)

Example:

import FreeCAD, Arch

Box = FreeCAD.ActiveDocument.addObject("Part::Box", "Box")
Box.Length = 1000
Box.Width = 1000
Box.Height = 1000

Space = Arch.makeSpace(Box)
Space.ViewObject.LineWidth = 2
FreeCAD.ActiveDocument.recompute()

After a space object is created, selected faces can be added to it with the following code:

import FreeCAD, FreeCADGui, Draft, Arch

points = [FreeCAD.Vector(-500, 0, 0), FreeCAD.Vector(1000, 1000, 0)]
Line = Draft.makeWire(points)
Wall = Arch.makeWall(Line, width=150, height=2000)
FreeCAD.ActiveDocument.recompute()

# Select a face of the wall
selection = FreeCADGui.Selection.getSelectionEx()
Arch.addSpaceBoundaries(Space, selection)

Boundaries can also be removed, again by selecting the indicated faces:

selection = FreeCADGui.Selection.getSelectionEx()
Arch.removeSpaceBoundaries(Space, selection)


{{docnav/uk|Roof/uk|Stairs/uk|[[Arch_Module/uk|Arch]uk]|IconL=Arch_Roof.svg |IconC=Workbench_Arch.svg |IconR=Arch_Stairs.svg}}